local bullet = {}
local bulletcolor ={255,255,255,255}

local function drawBullet()
	for i,v in ipairs(bullet) do
		g.setColor(bulletcolor)
		g.rectangle('line',v.x,v.y,v.w,v.h)
	end
end

local function updatethebullet(dt)
		for i,v in ipairs(bullet) do
			
			--fired right
			if v.id==1 then
				v.x = v.x + v.speed*dt
				if v.x >= b.x+300 then
					table.remove(bullet,i)
				end
			end
			
			--fired left
			if v.id==2 then
				v.x = v.x - v.speed*dt
				if v.x <= b.x-300 then
					table.remove(bullet,i)
				end
			end
						
			--fired up
			if v.id==3 then
				v.y = v.y - v.speed*dt
				if v.y <= b.y-300 then
					table.remove(bullet,i)
				end
			end
			
			--fired down
			if v.id==4 then
				v.y = v.y + v.speed*dt
				if v.y >= b.y+300 then
					table.remove(bullet,i)
				end
			end
			
		end
	
end

local function bulletshoot(key)
	if (key == " ") and (b.state== "right") then	
		table.insert( bullet, { x = b.x+25 , y = b.y+50 , w=10 , h=10 , speed =800 , id =1} )
		
	elseif (key == " ") and (b.state== "left") then
		table.insert( bullet, { x = b.x+25 , y = b.y+50 , w=10 , h=10 , speed =800 , id =2} )
		
	elseif (key == " ") and (b.state== "up") then
		table.insert( bullet, { x = b.x+25 , y = b.y+50 , w=10 , h=10 , speed =800 , id =3} )
		
	elseif (key == " ") and (b.state== "down") then
		table.insert( bullet, { x = b.x+25 , y = b.y+50 , w=10 , h=10 , speed =800 , id =4} )		
	end
	
end



-------------------------------------------------------
---                     SEPARATOR                    --
-------------------------------------------------------


box={}
function box:load()
	b={
		x=100,
		y=300,
		w=50,
		h=100,
		xvelocity=0,
		yvelocity=0, 	
		state="stand"	
	}
	--variables
	run =500--the speed	
	boxcolor={0,255,0,255}
	textcolor={255,255,255,255}
end

function box:draw()	
	g.setColor(boxcolor)
	g.rectangle("line", b.x,b.y ,b.w, b.h)	
	
	--bullet draw
	drawBullet()
end

function box:update(dt)
	--updater will update x and y--
	b.x = b.x + b.xvelocity * dt
	b.y = b.y + b.yvelocity * dt

	--DPAD
	if k.isDown("d") then  b.xvelocity = 	run end--right
	if k.isDown("a") then  b.xvelocity = -1 * run  end--left	
	
	if k.isDown("w") then  b.yvelocity = -1 * run end--up
	if k.isDown("s") then  b.yvelocity =	run  end--down	
	
	--update bullets
	updatethebullet(dt)
end

function box:mousepressed(x, y, button)
end

function box:mousereleased(x, y, button)
end

function box:keypressed(key)
	--shoot bullet
	bulletshoot(key)
	
	--while pressed
	if (key == "d" ) then b.state="right" end
	if (key == "a" ) then b.state="left"  end	
	if (key == "w" ) then b.state="up"    end	
	if (key == "s" ) then b.state="down"  end
end

function box:keyreleased(key)
	--stop moving
    if (key == "d") or (key == "a") or (key == "s") or (key == "w")  then  
         b.xvelocity = 0;	b.yvelocity = 0;	state="stand" 		
    end
	--while released
	if (key == "d" ) then b.state="right" end
	if (key == "a" ) then b.state="left"  end	
	if (key == "w" ) then b.state="up"    end	
	if (key == "s" ) then b.state="down"  end
	
end

function box:focus(f)
end

function box:quit() 
end